use 5.006;
use ExtUtils::MakeMaker;


WriteMakefile(
	      'NAME'		=> 'NAT',
	      'VERSION_FROM'	=> 'NAT.pm',
	      'EXE_FILES'    => [qw!scripts/nat-lex2perl
                                    scripts/nat-tmx2pair
                                    scripts/nat-pair2tmx
                                    scripts/nat-dumpDicts
                                    scripts/nat-rank
                                    scripts/nat-translate-shell
				    scripts/nat-sentence-align
				    scripts/nat-dict
			            scripts/nat-these
				    scripts/nat-this!],
	      'PREREQ_PM'	=> {
				    Lingua::PT::Atomizador  => '0.01',
				    Lingua::PT::Segmentador => '0.01',

				    XML::TMX          => '0.05',
				    XML::DT           => '0.27',
				    Compress::Zlib    => '1.16',
				    Test::Harness     => '2.26',
				    Storable          => '2.04',
				    MLDBM             => '2.00',
				    Fcntl             => '1.03',
				    DB_File           => '1.804',
				    IPC::Open2        => '1.01',
				    Term::ANSIColor   => '1.03',
				    Time::HiRes       => '1.2',
				    Config::Simple    => '4.55',
				   },
	      'DEFINE' 	        => '',
	      'MAKEFILE'        => 'Makefile.in',
	      'SKIP'            => [ qw/dist
					dist_basics
					dist_core
					dist_dir
					dist_test
					dist_ci/ ],
	     );



sub MY::postamble {
  local $/ = undef;
  my $postamble = <DATA>;
}

__DATA__
VERSION = @VERSION@
PACKAGE = @PACKAGE@

top_distdir = ..
distdir = $(top_distdir)/$(PACKAGE)-$(VERSION)/NAT

distdir:
	mkdir -p $(distdir)
	perl -MExtUtils::Manifest -e 'ExtUtils::Manifest::manicopy(ExtUtils::Manifest::maniread("MANIFEST"),"$(distdir)","cp")'

check: test
