#!/usr/bin/perl -w

use CGI qw/:standard :cgi-lib/;
use Data::Dumper;
use NAT;

$yellow = 33;
$green = 66;

print header;

unless (param('path')) {
  print "<tt>path</tt> parameter is needed.\n";
  print ask_for_path("You can enter it here:");
  exit;
}
$path = param('path');

$nat = NAT::nat_open($path);
unless ($nat) {
  print "Error opening NAT configuration file (<tt>path = $path</tt>).\n";
  print ask_for_path("Try entering another <tt>path</tt>:");
  exit;
}

my $desc = $nat->get_description;

%color = (
	  blue => '#bbffff',
	  red => '#fbb',
	  green => '#bfb',
	  yellow => '#ffb',
	 );

my %args = Vars();
my ($dic1,$lex1);
my ($dic2,$lex2);

print while(<DATA>);

print "<div class=\"form\">",br,start_form();
print "<table width=\"80%\" align=\"center\"><tr><td style='border: none' colspan='2'>\n";
print "<b>$path</b>: $desc\n",hr;
print "</td></tr><tr><td style='border: none'>\n";
print "Change <tt>path:</tt></td><td style='border: none'>",input({-name=>"path", -value=>$path});
print "</td></tr><tr><td style='border: none'>\n";
print "Search word: </td><td style='border: none'>";
print input( { -name=>"search" } );
print "</td></tr><tr><td style='border: none' colspan='2'>\n";
print input( { -type=>"submit", -value=>"Get it!" } );
print "</td></tr></table>\n";
print end_form(),"</div>\n";

print "  <div class=\"body\">\n";
if ($args{search}) {
  my $word_to_search = lc($args{search});
  my $id1 = $nat->{lex1}->NAT::Lexicon::id_from_word($word_to_search);
  my $id2 = $nat->{lex2}->NAT::Lexicon::id_from_word($word_to_search);

  print entry($nat->{dic1}, $nat->{dic2}, $nat->{lex1}, $nat->{lex2}, $id1, 1) if $id1;
  print entry($nat->{dic2}, $nat->{dic1}, $nat->{lex2}, $nat->{lex1}, $id2, 2) if $id2;

  print "<h1>Word '$args{search}' not found</h1>" unless $id1 or $id2;

} else {
  if ($args{dic} && $args{dic} == 2) {
    ($dic1,$dic2) = ($nat->{dic2},$nat->{dic1});
    ($lex1,$lex2) = ($nat->{lex2},$nat->{lex1});
  } else {
    ($dic1,$dic2) = ($nat->{dic1},$nat->{dic2});
    ($lex1,$lex2) = ($nat->{lex1},$nat->{lex2});
  }

  if (defined($args{w})) {
    print entry($dic1, $dic2, $lex1, $lex2, $args{w}, $args{dic});
  } else {
    print entry($dic1, $dic2, $lex1, $lex2, 2, $args{dic});
  }
}


print <<'EO';
   <br/>
  </div>
 </body>
</html>
EO

sub entry {
  my ($hash1,$hash2,$lex1,$lex2,$wid,$dic) = @_;

  if ($dic && $dic == 2) {
    ($dic1,$dic2) = (1,2);
  } else {
    $dic = 1; 			# isto no devia ser necessrio
    ($dic1,$dic2) = (2,1);
  }

  if ($hash1->exists($wid)) {
    my $word = $lex1->word_from_id($wid);
    my $ret = "<h1>$word</h1>";

    $ret .= "<table width=\"50%\"><tr>";
    my $trans = $hash1->vals($wid);
    my %hash = (@{$trans});
    for my $y (sort {$hash{$b} <=> $hash{$a}} keys %hash) {

      my $calc = $hash{$y}*100;
      my $bclass="background-color: $color{red};";
      $bclass = "background-color: $color{yellow};" if ($calc >= $yellow);
      $bclass = "background-color: $color{green};" if ($calc >= $green);
      $ret .= sprintf("<td class='color' rowspan=\"2\" style=\"padding: 4px; $bclass\"> %.2f%%</td>",$calc);

      my $class = "";
      my $trans2 = $hash2->vals($y);
      my %trans2 = (@$trans2);
      $class = "background-color: $color{blue}" if (exists($trans2{$wid}));

      $ret .= "<td style=\"$class\">";
      $wy = $lex2->word_from_id($y);
      $ret .= "<a href=\"$ENV{SCRIPT_NAME}?w=$y&dic=$dic1&path=$path\">$wy</a></td>\n";

      if ($wy eq "(null)") {
	$ret .= "<td colspan=\"2\">&nbsp;</td>";
      } else {
	$ret .= "<td class=\"oc\">".$hash2->occ($y)."</td>\n";
	$ret .= "<td class=\"oc\">";
	$ret .= "<a href=\"nat-search.cgi?path=$path&search=$word&translation=$wy&crp=$nat->{$dic}\">>></a>";
	$ret .= "</td>\n";
      }

      $ret .= "</tr><tr>";
      $ret .= "<td colspan=\"3\" style=\"padding: 0px\; border: 0\">";

      $ret .= "<table width='100%'>";
      for my $x (sort {($trans2{$b} <=> $trans2{$a})||0} keys %trans2) {

	my $bclass="background-color: $color{red};";
	my $calc = $trans2{$x}*100;
	$bclass = "background-color: $color{yellow};" if ($calc >= $yellow);
	$bclass = "background-color: $color{green};" if ($calc >= $green);

	$ret .= sprintf("<tr><td class='color' style=\"padding: 2px; $bclass\">%.2f%%</td>\n",$calc);
	$ret .= "<td class=\"oc\">".$hash1->occ($x)."</td>\n";
	$ret .= "<td width=\"80%\">";
	my $wx = $lex1->word_from_id($x);
	$ret .= "<a href=\"$ENV{SCRIPT_NAME}?w=$x&dic=$dic2&path=$path\">$wx</a></td>\n";
	$ret .= "</tr>";
      }
      $ret .= "</table>";
      $ret .= "</td></tr>";
    }
    $ret .= "</table>";
    return $ret;
  } else {
    return "<h1>Word not found!!\n</h1>";
  }
}

sub count {
  my $hash = shift;
  my $word = shift;
  return (defined($hash->{$word}{count}))?$hash->{$word}{count}:"&nbsp;";
}

sub ask_for_path {
  my $text = shift;
  my $ret = "<p>".start_form();
  $ret .= "$text&nbsp;".input( { -name=>"path" });
  $ret .= input( {-type=>"submit",-value=>"Enter"});
  $ret .= end_form();
}

__DATA__
<html>
 <head>
  <style>
   div.right { text-align: right }
   table     { padding: 0px; border-collapse: separate; border-spacing: 2px }
   td        { padding: 2px; border: solid 1px #000; }
   td.color  { font-weight: bold; text-align: right; width: 10%; }
   td.oc     { text-align: right; width: 10%; }
   hr { border: none; border-top: solid 1px #000 }
   a         { font-weight: bold; text-decoration: none; }
   a:visited { color: #009; }
   a:hover   { text-decoration: underline; }
       .body { margin-left: 10%; margin-right: 10%; }
       .form { background-color: #efe;
         margin-bottom: 10px;
         margin-left: 10%;
         margin-right: 10%;
         border: solid 1px #000;
         text-align: center;
       }
 input { border: solid 1px #999;
         padding: 2px;  }
 input[type=submit]:hover {
   background-color: #fff;
         border: solid 1px #000;
         padding: 2px;  }

  </style>
  <title>nat-browse</title>
 </head>
 <body>




