# -*- cperl -*-

use Test::More;
BEGIN { plan tests => 28 };

use NAT;
ok(1);     # If we made it this far, we're ok.
use NAT::PCorpus;
ok(1);
use NAT::Dict;
ok(1);

# check normalizetion ################################################

is(NAT::normalize("    teste"), "teste");
is(NAT::normalize("teste    "), "teste");
is(NAT::normalize("  teste  "), "teste");
is(NAT::normalize("	teste"), "teste");
is(NAT::normalize("\nteste	"), "teste");

is(NAT::normalize("espaos   no meio"), "espaos no meio");
is(NAT::normalize("espaos   no	meio"), "espaos no meio"); #este tem um tab...

is(NAT::normalize("	espaos misturados	com tabs"),
   "espaos misturados com tabs");
is(NAT::normalize("	espaos\nmisturados	com new\nlines	"),
   "espaos misturados com new lines");

# check search #######################################################

my %data = (
	    Gato => "1",
	    rato => "2",
	    COELHO => "3",
	   );

is(NAT::search(\%data, "gato"  ), "Gato");
is(NAT::search(\%data, "Rato"  ), NAT::search(\%data, "Rato"));
is(NAT::search(\%data, "Coelho"), NAT::search(\%data, "coelho"));
is(NAT::search(\%data, "CoElHo"), "COELHO");
is(NAT::search(\%data, "pinto" ), undef);
is($data{NAT::search(\%data, "gato")}, 1);
is($data{NAT::search(\%data, "RATO")}, 2);
is($data{NAT::search(\%data, "coELHO")}, 3);

# check mean0 ########################################################
is(NAT::mean0(),0);
is(NAT::mean0(1),1);
is(NAT::mean0(1,1),1);
is(NAT::mean0(1,0),.5);
is(NAT::mean0(0,0),0);
is(NAT::mean0(1..9),5);
is(NAT::mean0(1,0,0,0,0,0,0,0,0,0),.1);
is(NAT::mean0(1,1,1,undef,5,4,3,2,1),1);

################################################################ EOF #
