/* -*- Mode: C; c-file-style: "stroustrup" -*- */

/**********************************************
 * SEE COPYING FILE FOR COPYRIGHT INFORMATION *
 **********************************************
 * 
 * - dict.h	: library file containing dictionary data structure
 */


struct cItem {
    struct cItem *nextC;
    guint32 row, column, value;
};

struct cMat2 {
    guint32 Nrows, Ncolumns;       /* Number of rows & columns */
    struct cItem **firstR, **firstC;      /* list of pointers to first item per row & column */
    struct cItem *items;                  /* sparse data structure */
    guint32 clean;                 /* boolean 0 = matrix is dirty, 1 = matrix = clean */ 
    long p, memory;                       /* pointer to empty space & memory available */
};

int AllocMatrix2(struct cMat2 *Matrix, guint32 Nrow, guint32 Ncolumn);
void FreeMatrix2(struct cMat2 *Matrix);
int DirtyPutValue2(struct cMat2 *Matrix, float f, guint32 r, guint32 c);
float GetValue2(struct cMat2 *Matrix, guint32 r, guint32 c);
float GetRowMax2(struct cMat2 *Matrix, guint32 r, guint32 *c, float *f, guint32 max);
float GetColumnMax2(struct cMat2 *Matrix, guint32 c, guint32 *r, float *f, guint32 max);
void SetRowPointers(struct cMat2 *Matrix);
void SetColumnPointers(struct cMat2 *Matrix);
int CleanMatrix2(struct cMat2 *Matrix);
int LoadMatrix2(struct cMat2 *Matrix, const char *filename);
int SaveMatrix2(struct cMat2 *Matrix, const char *filename);
