#ifndef __DICTIONARY_H__
#define __DICTIONARY_H__

#include <glib.h>

#define MAXENTRY 8

#define DIC_POS(dic,word,j)   dic[word*MAXENTRY+j]

typedef struct dpair {
    guint32 id;
    float val;
} DicPair;

typedef struct dictionary {
    DicPair *pairs;
    guint32 *occurs;
    guint32 size;
} Dictionary;

Dictionary *dictionary_new(guint32 size);
void        dictionary_free(Dictionary *dic);
Dictionary *dictionary_set_id(Dictionary* dic, guint32 wid, guint32 offset, guint32 id);
Dictionary *dictionary_set_val(Dictionary* dic, guint32 wid, guint32 offset, float val);
Dictionary *dictionary_set_occ(Dictionary* dic, guint32 wid, guint32 count);
guint32     dictionary_get_occ(Dictionary* dic, guint32 wid);
guint32     dictionary_get_id(Dictionary* dic, guint32 wid, guint32 offset);
float       dictionary_get_val(Dictionary* dic, guint32 wid, guint32 offset);
guint32     dictionary_get_size(Dictionary* dic);
int         dictionary_save(Dictionary *dic, const char *name);
Dictionary* dictionary_open(const char *name);
Dictionary* dictionary_add(Dictionary *dic1, Dictionary *dic2);
double      dictionary_sentence_similarity(Dictionary *dic,
					   guint32 *s1, int s1size, guint32 *s2, int s2size);


#endif
