#include "standard.h"

typedef struct cWordLstNode {
    guint32  id;
    guint32  count;
    char    *string;

    /* binary tree branchs */
    struct cWordLstNode *left;
    struct cWordLstNode *right;
} WordLstNode; 

typedef struct cWordList {
    guint32      count;
    WordLstNode* tree;
} WordList;


WordList *word_list_new      (void);
guint32   word_list_add_word (WordList      *list, 
			      char          *string);
WordList *word_list_add_full (WordList      *list,
			      guint32        id,
			      guint32        count,
			      const char    *string,
			      WordLstNode ***ptr);
WordList *word_list_load     (const char    *filename,
			      WordLstNode ***ptr);
void      word_list_print    (char          *title,
			      WordList      *lst);
void      word_list_free     (WordList      *lst);
char     *word_list_get_by_id(WordLstNode  **ptr,
			      guint32        index);
WordLstNode *word_list_get_full_by_id(WordLstNode  **ptr,
				   guint32        index);
guint32   word_list_size     (WordList      *list);
gboolean  word_list_save     (WordList      *list,
			      char          *filename);
guint32   word_list_get_id   (WordList      *lst,
			      const char    *string);
